import os
import requests
import execjs
import re

path0=os.getcwd()
path=path0+"\mytxt"

#读取文档内容
def read_txt(path):
    with open(path,'r') as f:
        content = f.read()
        f.close()
    return content

#谷歌翻译
class GoogleTranslate(object):
    def __init__(self):
        self.ctx = execjs.compile(  # 下面是一段js代码，从网页中分析得到
            """ function TL(a) { var k = ""; var b = 406644; var b1 = 3293161072; var jd = "."; var $b = "+-a^+6"; var Zb = "+-3^+b+-f"; for (var e = [], f = 0, g = 0; g < a.length; g++) { var m = a.charCodeAt(g); 128 > m ? e[f++] = m : (2048 > m ? e[f++] = m >> 6 | 192 : (55296 == (m & 64512) && g + 1 < a.length && 56320 == (a.charCodeAt(g + 1) & 64512) ? (m = 65536 + ((m & 1023) << 10) + (a.charCodeAt(++g) & 1023), e[f++] = m >> 18 | 240, e[f++] = m >> 12 & 63 | 128) : e[f++] = m >> 12 | 224, e[f++] = m >> 6 & 63 | 128), e[f++] = m & 63 | 128) } a = b; for (f = 0; f < e.length; f++) a += e[f], a = RL(a, $b); a = RL(a, Zb); a ^= b1 || 0; 0 > a && (a = (a & 2147483647) + 2147483648); a %= 1E6; return a.toString() + jd + (a ^ b) }; function RL(a, b) { var t = "a"; var Yb = "+"; for (var c = 0; c < b.length - 2; c += 3) { var d = b.charAt(c + 2), d = d >= t ? d.charCodeAt(0) - 87 : Number(d), d = b.charAt(c + 1) == Yb ? a >>> d: a << d; a = b.charAt(c) == Yb ? a + d & 4294967295 : a ^ d } return a } """)

    def getTk(self, text):  # 计算谷歌的算法值
        return self.ctx.call("TL", text)

    def translate(self, content, en_to_zn=True):
        """
        :param content: 翻译内容
        :param en_to_zn: 是否由英文翻译成中文，默认为True
        :return:
        """
        if len(content) > 4891:
            print("翻译的长度超过限制！！！")
            return
        tk = self.getTk(content)
        param = {'tk': tk, 'q': content}
        url_en_to_zh = 'https://translate.google.cn/translate_a/single?client=t&sl=zh-CN&tl=en&hl=zh-CN&dt=at&dt=bd&dt=ex&dt=ld&dt=md&dt=qca&dt=rw&dt=rm&dt=ss&dt=t&ie=UTF-8&oe=UTF-8&otf=1&ssel=6&tsel=3&kc=1'

        url_zh_to_en = "https://translate.google.cn/translate_a/single?client=t&sl=en &tl=zh-CN&hl=zh-CN&dt=at&dt=bd&dt=ex&dt=ld&dt=md&dt=qca&dt=rw&dt=rm&dt=ss &dt=t&ie=UTF-8&oe=UTF-8&clearbtn=1&otf=1&pc=1&srcrom=0&ssel=0&tsel=0&kc=2"

        # 返回的结果为Json，解析为一个嵌套列表
        result = requests.get(url_en_to_zh if en_to_zn else url_zh_to_en, params=param)
        results = result.json()[0]
        data = []
        for test in results:
            if test[0]:
                data.append(test[0])
        return '\n'.join(data), data


if __name__ == "__main__":
    tran = GoogleTranslate()
    for root, dirs, files in os.walk(path):
        for name in files:
            x = os.path.join(root, name)
            con = read_txt(x)
            con = con.replace("\n", "")   # 删除换行符
            content = con
            num=int(len(content)/4000)+1
            last_str=""
            last_con=""
            for i in range(num):
                pattern = r"[.|。]"
                con_0=last_str+content[4000*i:4000*(i+1)]
                result = re.split(pattern, con_0)
                last_str=result[-1]
                con_1=con_0[0:len(con_0)-len(last_str)]
                data = tran.translate(con_1, en_to_zn=False)
                last_con=last_con+"*"*50+data[0]
            filename = path0 + "\mytxt_translate"+"\\"+name
            file_txt = open(filename, 'w')
            txt=str(last_con)
            txt=txt.replace("\n","")
            file_txt.write(txt)
            file_txt.close()
            print(name ,"翻译结束")
